---
#    Cluster freeze                       - ansible
#    Stop managed server                  - ansible
#    Undeploy old application             - ansible
#    Remove cache, stage, tmp folder      - ansible
#    Deploy application                   - ansible
#    Start managed server                 - ansible
#
#    4. Final
#    Check application status               - ansible
#    Register version

#### Determine Active cluster node

- name: Check mount_point
  ansible.builtin.import_role:
    name: mount_check

- ansible.builtin.meta: end_host
  when:
    - cluster != '0'

- name: Freeze cluster if needed
  ansible.builtin.import_role:
    name: freeze_cluster
  when:
    - "'cluster_host' in group_names"

- name: Create scripts folder
  ansible.builtin.file:
    path: "{{ wlst_folder_path  }}"
    state: directory
    owner: "{{ wl_user }}"
    group: "{{ wl_group }}"

- name: Set bucket
  ansible.builtin.set_fact:
    bucket: "{{ deploy_wl_app_path.split('/')[2] }}"
    oos_path: "{{ deploy_wl_app_path.split('/')[3:]| join('/') }}"

- name: Set path for app
  ansible.builtin.set_fact:
    deploy_wl_app_dest: "{{ wl_home}}/SV_Patches/{{ deploy_wl_app_path | basename }}"

- name: Copy application to the local filesystem
  become: false
  delegate_to: localhost
  amazon.aws.s3_object:
    bucket: "{{ bucket }}"
    object: "{{ oos_path }}"
    dest: "{{ playbook_dir }}/../files/SV_Patches/{{ deploy_wl_app_path | basename }}"
    mode: get
    secret_key: "{{ s3cmd_secret_key }}"
    access_key: "{{ s3cmd_access_key }}"
    endpoint_url: "https://{{ s3cmd_endpoint }}"
    region: "{{ s3cmd_region }}"
    validate_bucket_name: false
    debug_botocore_endpoint_logs: true
  register: result

- name: Create path for app
  ansible.builtin.file:
    path: "{{ wl_home}}/SV_Patches/"
    owner: "{{ wl_user }}"
    group: "{{ wl_group }}"
    state: directory

- name: Copy app to Weblogic host
  ansible.builtin.copy:
    src: "{{ playbook_dir }}/../files/SV_Patches/{{ deploy_wl_app_path | basename }}"
    dest: "{{ deploy_wl_app_dest }}"
    owner: "{{ wl_user }}"
    group: "{{ wl_group }}"

- name: Set vars for W12.1
  ansible.builtin.set_fact:
    script_folder: 'scripts12'
    conffile: 'configfile.secure12'
    keyfile: 'keyfile.secure12'
  when: wl_version.version == 12

- name: Set script folder for W14
  ansible.builtin.set_fact:
    script_folder: 'scripts14'
    conffile: 'configfile.secure14'
    keyfile: 'keyfile.secure14'
  when: wl_version.version in (141, 142)

- name: Set script folder for W12.2
  ansible.builtin.set_fact:
    script_folder: 'scripts122'
    conffile: 'configfile.secure122'
    keyfile: 'keyfile.secure122'
  when: wl_version.version in (122, 124)

- name: Copy WLST class
  ansible.builtin.template:
    src: "{{ wlst_file_path }}/wlst.py"
    dest: "{{ wlst_folder_path }}/wlst.py"
    owner: "{{ wl_user }}"
    group: "{{ wl_group }}"
    backup: true

#- ansible.builtin.debug:
#    msg: "Domain middleware home: {{ domain.middleware_home }}, {{ wlst_folder_path }} {{ deploy_wl_app_name }} {{ app_dest }}
#    {{ deploy_wl_release }} {{ deploy_wl_cleanup_cache}} {{ domain }}"

- name: Run deploy {{ deploy_wl_app_name }}
  ansible.builtin.shell: |
    {{ domain.middleware_home }}/oracle_common/common/bin/wlst.sh {{ wlst_folder_path }}/wlst.py deploy_single {{ deploy_wl_app_name }} {{ deploy_wl_app_dest }} {{ deploy_wl_release }} {{ deploy_wl_cleanup_cache }}
  register: result
